package decatur.de.rigorous.numutil;
import java.awt.*;

public class ErrorDialog extends Dialog {
  private Label errorLabel;

  public ErrorDialog (Frame parent, String name, boolean modal) {
    super (parent, name , modal);
    setSize (200, 100);
    add ("South", new Button ("ok"));
    errorLabel = new Label();
    errorLabel.setAlignment (Label.CENTER);
    add ("Center", errorLabel);
  }

  public void show (String error) {
    errorLabel.setText (error);
    super.setVisible(true);
  }

  public boolean action (Event evt, Object obj) {
    if ("ok".equals (obj) )
      dispose ();
    return true;
  }
}
