package decatur.de.rigorous.plot;

import java.awt.*;

public class GuiLabelComponent extends Panel {
    TextCanvas text;
    GridBagLayout gridBag;
    GridBagConstraints gbc;

    public GuiLabelComponent () {
	setLayout (gridBag = new GridBagLayout());
	gbc = new GridBagConstraints();
	text = new TextCanvas ();
	text.setFormat ("l");
	text.incFontSize (2);
	gbc.fill = GridBagConstraints.NONE;
	gbc.anchor = GridBagConstraints.NORTHWEST;
	gbc.ipady = 5;
	gbc.gridwidth = GridBagConstraints.REMAINDER;
	gridBag.setConstraints (text, gbc);
	add (text);
    }

    public GuiLabelComponent (String s, Component c) {
	this ();
	setLabel (s);
	setComponent (c);
    }

    public void setLabel (String s) {
	text.addRow (s);
	invalidate ();
    }

    public void setComponent (Component c) {
	gbc.fill = GridBagConstraints.BOTH;
	gridBag.setConstraints (c, gbc);
	add (c);
	invalidate ();
    }
}
