package decatur.de.rigorous.plot;


public class SoMatrixAction extends SoAction {
  
    private SbMatrix found, matrix;
    private SoNode node;

    public SoMatrixAction (SoNode node) {
	this.node = node;
	matrix = new SbMatrix ();
    }
    
    public SbMatrix getMatrix () {
	return found;
    }    

    void apply (SoNode node) {
	if ( node instanceof SoGroup ) {
	    SoGroup group = (SoGroup) node;
	    SbMatrix save = null;
	    if ( group instanceof SoSeparator ) {
		save = matrix;
		matrix = new SbMatrix (save);
	    }
		
	    for (int i=0; i<group.children.size(); i++)
		apply ((SoNode) (group.children.elementAt(i)));

	    if ( group instanceof SoSeparator )
		matrix = save;
	} else if ( node instanceof SoTransform ) {
	    SoTransform transform = (SoTransform) node;
	    matrix.translate (transform.tx, transform.ty);
	    matrix.scale (transform.sx, transform.sy);
	}
	if ( node==this.node ) found = new SbMatrix (matrix);
    }
}
