package decatur.de.rigorous.plot;

public class SoRenderAction extends SoAction {

    Device device;

    public SoRenderAction () {
    }

    public SoRenderAction (Device dev) {
	setDevice (dev);
    }

    public void setDevice (Device dev) {
	device = dev;
    }

    void apply (SoNode node) {
	if ( node instanceof SoGroup ) {
	    SoGroup group = (SoGroup) node;
	    if ( group instanceof SoSeparator )
		device.pushState ();
		
	    for (int i=0; i<group.children.size(); i++)
		apply ((SoNode) (group.children.elementAt(i)));

	    if ( group instanceof SoSeparator )
		device.popState ();
	} else
	    node.render (device);
	
    }
}
