package decatur.de.rigorous.plot;

public class SoColorOrder {
    private int[] colortab = {0x000000, 0x0000ff, 0xff0000,
			      0xff00ff, 0x00ffff, 0xffff00,
			      0x00ff00, 0xff5500, 0x7f7f7f};

    private int colorpos=0;

    public SoColorOrder () {
	reset ();
    }

    public int next () {
	colorpos++;
	colorpos %= colortab.length;	
	return colortab[colorpos];
    }

    public void reset () {
	colorpos = colortab.length-1;
    }



}
